/*
 * include/asm-arm/arch-vnc/irq.h
 *
 * Copyright 1997 Corel Computer
 */



/* foot bridge irq control */
#if 0
#define IRQ_CLEAR       ((volatile unsigned int *)(DC21285_ARMCSR_BASE + IRQ_ENABLE_CLEAR))
#define IRQ_SET         ((volatile unsigned int *)(DC21285_ARMCSR_BASE + IRQ_ENABLE_SET))
#define IRQ_SHOW        ((volatile unsigned int *)(DC21285_ARMCSR_BASE + IRQ_ENABLE))
#else /* mmu turned on */
#define IRQ_CLEAR       ((volatile unsigned int *)(IO_BASE_ARM_CSR + IRQ_ENABLE_CLEAR))
#define IRQ_SET         ((volatile unsigned int *)(IO_BASE_ARM_CSR + IRQ_ENABLE_SET))
#define IRQ_SHOW        ((volatile unsigned int *)(IO_BASE_ARM_CSR + IRQ_ENABLE))
#endif

/* PIC irq control */
#define PIC_MASK_LO 0x21
#define PIC_MASK_HI 0xA1
#define PIC_LO 0x20
#define PIC_HI 0xA0

#define BUILD_IRQ(s,n,v)

extern void IRQ_interrupt(void);
extern void timer_IRQ_interrupt(void);
extern void fast_IRQ_interrupt(void);
extern void bad_IRQ_interrupt(void);
extern void probe_IRQ_interrupt(void);

#define IRQ_interrupt0 timer_IRQ_interrupt
#define IRQ_interrupt1 IRQ_interrupt
#define IRQ_interrupt2 IRQ_interrupt
#define IRQ_interrupt3 IRQ_interrupt
#define IRQ_interrupt4 IRQ_interrupt
#define IRQ_interrupt5 IRQ_interrupt
#define IRQ_interrupt6 IRQ_interrupt
#define IRQ_interrupt7 IRQ_interrupt
#define IRQ_interrupt8 IRQ_interrupt
#define IRQ_interrupt9 IRQ_interrupt
#define IRQ_interrupt10 IRQ_interrupt
#define IRQ_interrupt11 IRQ_interrupt
#define IRQ_interrupt12 IRQ_interrupt
#define IRQ_interrupt13 IRQ_interrupt
#define IRQ_interrupt14 IRQ_interrupt
#define IRQ_interrupt15 IRQ_interrupt
#define IRQ_interrupt16 timer_IRQ_interrupt
#define IRQ_interrupt17 IRQ_interrupt
#define IRQ_interrupt18 IRQ_interrupt
#define IRQ_interrupt19 IRQ_interrupt
#define IRQ_interrupt20 IRQ_interrupt
#define IRQ_interrupt21 IRQ_interrupt
#define IRQ_interrupt22 IRQ_interrupt
#define IRQ_interrupt23 IRQ_interrupt
#define IRQ_interrupt24 IRQ_interrupt
#define IRQ_interrupt25 IRQ_interrupt
#define IRQ_interrupt26 IRQ_interrupt
#define IRQ_interrupt27 IRQ_interrupt
#define IRQ_interrupt28 IRQ_interrupt
#define IRQ_interrupt29 IRQ_interrupt
#define IRQ_interrupt30 IRQ_interrupt
#define IRQ_interrupt31 IRQ_interrupt

#define IRQ_INTERRUPT(n)	IRQ_interrupt##n
#define FAST_INTERRUPT(n)	fast_IRQ_interrupt
#define BAD_INTERRUPT(n)	bad_IRQ_interrupt
#define PROBE_INTERRUPT(n)	probe_IRQ_interrupt

unsigned long get_enabled_irqs(void);
void irq_init_irq(void);
void unmask_irq(unsigned int irq);
void mask_irq(unsigned int irq);

